<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$v" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionNegocio }}</strong>
    </div>
    <!--Contenido-->
    <div class="contSecc">
      <div class="titSec">{{ textoGestionNegocio }}</div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <v-row>
        <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
          <v-row>
            <v-col>
              Nombre del negocio
              <span class="tRojo">*</span>
              <v-text-field
                v-model.trim="negocio.descripcion"
                maxlength="50"
                outlined
                solo
                flat
                dense
                :error="$v.negocioVuelidate.descripcion.$error"
                hint-align="right"
                :hint="
                  'CARACTERES RESTANTES ' +
                    serviceCommons.remaningCharacters(negocio.descripcion, 50)
                "
                background-color="white"
              >
                <template
                  v-if="
                    $v.negocioVuelidate.descripcion.$error || !isUniqueNegocio
                  "
                  v-slot:append
                >
                  <v-popover placement="bottom-end" color="red" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <div
                        @click="$v.negocioVuelidate.descripcion.$reset"
                        v-close-popover
                      >
                        <div v-if="!$v.negocioVuelidate.descripcion.required">
                          ¡No te olvides de éste campo!
                        </div>
                        <div
                          @click="isUniqueNegocio = !isUniqueNegocio"
                          v-if="
                            !isUniqueNegocio &&
                              $v.negocioVuelidate.descripcion.required
                          "
                        >
                          ¡Encontramos su gemela! nombre del negocio duplicado
                        </div>
                      </div>
                    </template>
                  </v-popover>
                </template>
              </v-text-field>
              <v-text-field
                v-model="searchCategoria"
                clearable
                label="Buscar..."
                class="float-right pt-0 mt-0"
                v-if="false"
              >
                <template v-slot:append>
                  <v-tooltip bottom>
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on">mdi-card-search-outline</v-icon>
                    </template>
                    Buscar
                  </v-tooltip>
                </template>
              </v-text-field>
              <div class="titSec">
                <div style="width:115px">
                  Categorías
                  <span class="tRojo">*</span>
                  <div
                    v-if="$v.negocioVuelidate.categorias.$error"
                    class="float-right"
                  >
                    <v-popover placement="bottom-end" offset="16">
                      <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                      <template slot="popover">
                        <div
                          @click="$v.negocioVuelidate.categorias.$reset"
                          v-close-popover
                        >
                          <div v-if="!$v.negocioVuelidate.categorias.required">
                            ¡Mínimo es una categoría!
                          </div>
                          <div
                            v-if="
                              $v.negocioVuelidate.categorias.$error &&
                                $v.negocioVuelidate.categorias.required
                            "
                          >
                            ¡Es necesario validar todas las categorias!
                          </div>
                        </div>
                      </template>
                    </v-popover>
                  </div>
                </div>
              </div>
              <div class="gris" style="min-height: 263px;">
                <v-sheet
                  class="overflow-y-auto CardScrollCategoria"
                  style="background : none;"
                >
                  <template
                    v-for="(itemCategoria,
                    indexCategoria) in categoriasNegocioActive"
                  >
                    <v-card
                      v-show="!itemCategoria.found"
                      :key="indexCategoria"
                      class="mt-2"
                      color="transparent"
                    >
                      <v-btn
                        @click="
                          tempDeletingCategoria = itemCategoria;
                          tempIndexDeletingCategoria = indexCategoria;
                          dialogDelete = true;
                        "
                        small
                        class="float-right mt-9 mr-5"
                        text
                        icon
                      >
                        <v-img
                          :contain="true"
                          :aspect-ratio="1"
                          position="center"
                          src="@/assets/img/delete.svg"
                          class="white--text align-end"
                        ></v-img>
                      </v-btn>
                      <v-row>
                        <v-col
                          :cols="12"
                          :xs="2"
                          :sm="2"
                          :md="2"
                          :lg="2"
                          :xl="2"
                        >
                          No.
                          <v-text-field
                            class="mt-0 pt-1"
                            placeholder="No."
                            maxlength="2"
                            disabled
                            style="width:25px;"
                            flat
                            :value="itemCategoria.no"
                            background-color="white"
                          ></v-text-field>
                        </v-col>
                        <v-col
                          :cols="12"
                          :xs="10"
                          :sm="10"
                          :md="10"
                          :lg="10"
                          :xl="10"
                        >
                          Categoría
                          <span class="tRojo">*</span>
                          <v-text-field
                            class="mt-0 pt-1"
                            v-model.trim="itemCategoria.descripcion"
                            maxlength="50"
                            background-color="white"
                            :error="
                              $v.negocioVuelidate.categorias.$each[
                                indexCategoria
                              ].descripcion.$error
                            "
                            hint-align="right"
                            :hint="
                              'CARACTERES RESTANTES ' +
                                serviceCommons.remaningCharacters(
                                  itemCategoria.descripcion,
                                  50
                                )
                            "
                          >
                            <template
                              v-if="
                                $v.negocioVuelidate.categorias.$each[
                                  indexCategoria
                                ].descripcion.$error
                              "
                              v-slot:append
                            >
                              <v-popover
                                placement="bottom-end"
                                color="red"
                                offset="16"
                              >
                                <v-icon class color="#fd5151"
                                  >mdi-alert-circle</v-icon
                                >
                                <template slot="popover">
                                  <div
                                    @click="
                                      $v.negocioVuelidate.categorias.$each[
                                        indexCategoria
                                      ].descripcion.$reset;
                                    "
                                    v-close-popover
                                  >
                                    <div
                                      v-if="
                                        !$v.negocioVuelidate.categorias.$each[
                                          indexCategoria
                                        ].descripcion.required
                                      "
                                    >
                                      ¡No te olvides de éste campo!
                                    </div>
                                  </div>
                                </template>
                              </v-popover>
                            </template>
                          </v-text-field>
                        </v-col>
                      </v-row>
                    </v-card>
                  </template>
                </v-sheet>
              </div>
              <v-row>
                <v-col
                  class="text-center"
                  :cols="12"
                  sm="12"
                  md="12"
                  lg="12"
                  xl="12"
                >
                  <v-btn
                    small
                    class="black--text"
                    dark
                    tile
                    color="white"
                    @click="addNewCategoria"
                  >
                    <v-avatar size="20" tile>
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/icoSimpleAgregar.svg"
                        class="black--text"
                      ></v-img> </v-avatar
                    >Añadir nueva categoría
                  </v-btn>
                </v-col>
              </v-row>
            </v-col>
          </v-row>
        </v-col>
        <v-col>
          <div>
            <div style="background:#fafafa">
              <div class="contModal cmodal">
                <div class="amodal tCenter">
                  <div
                    class="myDropProtocolos dropzone dz-clickable dz-verfolow"
                    v-cloak
                    @drop.stop.prevent="readFile"
                    @dragover.prevent
                  >
                    <div
                      v-if="$v.negocioVuelidate.file.content_b64.$error"
                      class="float-right"
                    >
                      <v-popover placement="bottom-end" offset="16">
                        <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                        <template slot="popover">
                          <div
                            @click="$v.negocioVuelidate.file.content_b64.$reset"
                            v-close-popover
                          >
                            <div
                              v-if="
                                !$v.negocioVuelidate.file.content_b64.required
                              "
                            >
                              ¡No te olvides de la imagen!
                            </div>
                          </div>
                        </template>
                      </v-popover>
                    </div>
                    <div class="dz-default dz-message" data-dz-message>
                      <div>
                        <img
                          v-if="!negocio.file.content_b64"
                          src="@/assets/img/cloud-computing.svg"
                          style="height:300px;width:450px"
                          alt
                        />
                        <img
                          v-else
                          :src="
                            'data:' +
                              negocio.file.content_type +
                              ';base64,' +
                              negocio.file.content_b64
                          "
                          style="height:300px;width:450px"
                        />
                        <v-btn
                          @click="clearFile"
                          x-small
                          color="red"
                          fab
                          absolute
                          :class="[
                            {
                              desac: savingNegocio
                            }
                          ]"
                          v-if="negocio.file.name_file"
                        >
                          <v-avatar size="20">
                            <v-img
                              :contain="true"
                              :aspect-ratio="1"
                              position="center"
                              src="@/assets/img/delete-white.svg"
                              class="white--text align-end"
                            ></v-img>
                          </v-avatar>
                        </v-btn>
                      </div>
                      <br />
                      <div>
                        <b class="name-file">{{ negocio.file.name_file }}</b>
                        <br />
                        <b>
                          Arrastra y suelta tu logotipo aquí o
                          <label class="file-select">
                            <a class="dz-clickable"
                              >Selecciónalo de tu computadora</a
                            >
                            <input
                              type="file"
                              accept="image/*"
                              @change="readFile"
                              id="file-input"
                            />
                            <template
                              v-if="$v.negocioVuelidate.file.content_b64.$error"
                            >
                              <span class="float-right"> </span>
                            </template>
                          </label>
                        </b>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </v-col>
      </v-row>
    </div>
    <div class="btnCenter">
      <v-btn
        @click="dialogCancel = true"
        :class="[{ desac: !hasGlobalChanges }]"
        class="mr-6"
        depressed
        dark
        tile
        color="secundary"
        >Cancelar cambios</v-btn
      >
      <v-btn
        depressed
        dark
        tile
        color="primary"
        @click="guardarNegocio"
        :class="[
          { desac: !hasGlobalChanges },
          { desac: savingNegocio },
          { 'error-validation-btn': $v.$invalid }
        ]"
        >Guardar cambios</v-btn
      >
    </div>

    <!-- Dialogs-->
    <template>
      <v-dialog
        v-model="dialogErrorValidationNombreNegocio"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Ocurrio un error al validar el nombre del negocio
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidationNombreNegocio = false"
                >¡De acuerdo!</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
              <v-btn
                color="secondary"
                icon
                dark
                @click="dialogCancel = false"
                style="position: absolute;right: 0px;top: 0px;"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              Proceso correcto
            </div>
          </v-card-title>
          <v-card-text>
            ¡Se han
            <strong>guardado los cambios de manera exitosa!</strong>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="cardAddNegocio.to"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Regresar a Negocios</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSize" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡La imagen debe ser menor a
              <strong>1 MB!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSize = false"
                >Si, entiendo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogTypeFile" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              Formato incorrecto
            </div>
          </v-card-title>
          <v-card-text>
            ¡El archivo seleccionado parece no tener finta de un
            <strong>formato de imagen!</strong>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogTypeFile = false"
                >Si, entiendo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar esta categoria?</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="
                  dialogDelete = false;
                  tempDeletingCategoria = null;
                  tempIndexDeletingCategoria = null;
                "
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteTempCategoria"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>

<style scoped>
.tableBodyScroll tbody {
  display: block;
  max-height: 230px;
  overflow-y: scroll;
}
.CardScrollCategoria {
  max-height: 235px;
}

.tableBodyScroll thead,
tbody tr {
  display: table;
  width: 100%;
  table-layout: fixed;
}

.tblCategorias .gtab label.labelActive:after {
  content: "Activo";
  display: block;
  min-width: 50px;
}

.tblCategorias .gtab label:after {
  content: "Inactivo";
  display: block;
  min-width: 50px;
}

.tblCategorias tr td {
  border-bottom: 1px dashed rgba(112, 112, 112, 0.14);
  background-color: transparent !important;
  position: relative;
}

.tblCategorias tr td:first-child {
  width: 50px;
}

.tblCategorias tr th:first-child {
  width: 50px;
}

.tblCategorias tr td:first-child input {
  text-align: center;
}

.tblCategorias th {
  text-align: left !important;
  white-space: nowrap;
}

.tblCategorias td {
  justify-content: center;
}

.titSec {
  border-bottom: 2px solid black;
}

.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}

.ponderacion .fixed.tooltiptext3,
.fixed.tooltiptext4 {
  bottom: -15px;
  left: -40px;
}

.ponderacion .tooltiptext3 .tooltiptext4 {
  bottom: -40px;
  left: -60px;
}

.titSec .tooltiptext3 .tooltiptext4 {
  bottom: -30px;
  left: -40px;
}

.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}

.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0px;
  left: -110px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}

.tooltiptext3:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}

.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}

.tooltiptext3:after,
.tooltiptext3:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}

.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}

.uploading-image {
  display: flex;
}

.file-select > input[type="file"] {
  display: none;
}
</style>

<script>
import axios from "axios";
import Vuex from "vuex";
import { mapState } from "vuex";
import { required } from "vuelidate/lib/validators";
import store from "@/store";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
const urlServicesPlataformaFranquicia =
  store.state.urlServicesPlataformaFranquicia;
export default {
  name: "Component-GestionNegocios",
  components: {
    LeavePage
  },
  data() {
    return {
      savingNegocio: false,
      dialogCancel: false,
      dialogSave: false,
      dialogDelete: false,
      dialogErrorValidationNombreNegocio: false,
      isUniqueNegocio: true,
      dialogErrorValidation: false,
      dialogSize: false,
      dialogTypeFile: false,
      tempIndexDeletingCategoria: null,
      tempDeletingCategoria: null,
      searchCategoria: null,
      cardAddNegocio: {
        to: {
          name: "modelo_franquicia_catalogos_negocios"
        }
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Catalogos Negocios",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_catalogos_negocios"
          }
        }
      ],
      negocioBackup: {
        id_negocio: null,
        descripcion: "",
        categorias: [],
        file: {
          content_type: null,
          name_file: null,
          content_b64: null
        }
      },
      negocio: {
        id_negocio: null,
        descripcion: "",
        categorias: [],
        file: {
          content_type: null,
          name_file: null,
          content_b64: null
        }
      },
      textoGestionNegocio: null,
      access_token: serviceLocalStorage.getAccessToken()
    };
  },
  watch: {
    negocio: {
      deep: true,
      handler: function(before) {
        delete before.updated;
        delete before.inserted;
        delete this.negocioBackup.inserted;
        delete this.negocioBackup.updated;
        if (this.negocioBackup) {
          const negocioBackup = JSON.parse(JSON.stringify(this.negocioBackup));
          delete negocioBackup.categorias;
          const originalValue = JSON.stringify(negocioBackup).replace(/"/g, "");

          const current = JSON.parse(JSON.stringify(before));
          delete current.categorias;
          const currentValue = JSON.stringify(current).replace(/"/g, "");
          const hasGlobalChanges = originalValue !== currentValue;

          if (hasGlobalChanges) {
            if (before.id_negocio) {
              before.updated = true;
            } else {
              before.inserted = true;
            }
          }
        }
      }
    },
    "negocio.categorias": {
      deep: true,
      handler: function(before) {
        if (this.negocioBackup) {
          const negocioBackup = JSON.parse(JSON.stringify(this.negocioBackup));
          before.forEach((itemCategoria, indexItemCategoria) => {
            delete itemCategoria.updated;
            if (negocioBackup.categorias[indexItemCategoria]) {
              delete negocioBackup.categorias[indexItemCategoria].no;
              const originalValue = JSON.stringify(
                negocioBackup.categorias[indexItemCategoria]
              ).replace(/"/g, "");
              const curretnItemCategoria = JSON.parse(
                JSON.stringify(itemCategoria)
              );
              delete curretnItemCategoria.no;
              const currentValue = JSON.stringify(curretnItemCategoria).replace(
                /"/g,
                ""
              );
              const hasGlobalChanges = originalValue !== currentValue;
              if (hasGlobalChanges) {
                itemCategoria.updated = true;
                if (itemCategoria.deleted) {
                  delete itemCategoria.updated;
                }
              }
            }
          });
        }
      }
    }
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.negocioBackup) {
        delete this.negocioBackup.inserted;
        delete this.negocioBackup.updated;
        const negocioBackup = JSON.parse(JSON.stringify(this.negocioBackup));
        const originalValue = JSON.stringify(negocioBackup).replace(/"/g, "");

        let negocio = JSON.parse(JSON.stringify(this.negocio));
        delete negocio.inserted;
        delete negocio.updated;
        negocio.categorias.forEach((itemCategoria) => {
          delete itemCategoria.inserted;
          delete itemCategoria.updated;
          return itemCategoria;
        });
        const currentValue = JSON.stringify(negocio).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.negocio.id_negocio === undefined;
      }
    },
    categoriasNegocioActive() {
      let indexCategoria = 0;
      return this.negocio.categorias.filter((itemCategoriaNegocio) => {
        if (!itemCategoriaNegocio.deleted) {
          indexCategoria++;
          itemCategoriaNegocio.no = indexCategoria;
          if (this.searchCategoria && this.searchCategoria !== "") {
            itemCategoriaNegocio.found = !itemCategoriaNegocio.descripcion
              .toLowerCase()
              .includes(this.searchCategoria.toLowerCase());
            return itemCategoriaNegocio;
          } else {
            delete itemCategoriaNegocio.found;
            return itemCategoriaNegocio;
          }
        }
      });
    },
    negocioVuelidate() {
      let negocioVuelidate = JSON.parse(JSON.stringify(this.negocio));
      negocioVuelidate.categorias = negocioVuelidate.categorias.filter(
        (itemCategoria) => !itemCategoria.deleted
      );
      return negocioVuelidate;
    }
  },
  validations: {
    negocioVuelidate: {
      descripcion: {
        required
      },
      categorias: {
        required,
        $each: {
          descripcion: {
            required
          }
        }
      },
      file: {
        required,
        content_b64: {
          required
        }
      }
    }
  },
  methods: {
    initValues() {
      if (this.negocio.id_negocio) {
        this.textoGestionNegocio = "Editar un Negocio";
        this.breadcrumbs.push({
          text: "Editar negocio",
          disabled: true
        });
      } else {
        this.breadcrumbs.push({
          text: "Crear un Negocio",
          disabled: true
        });
        this.textoGestionNegocio = "Nuevo negocio";
      }
    },
    clearFile() {
      this.negocio.file = {
        content_type: null,
        name_file: null,
        content_b64: null
      };
    },
    deleteTempCategoria() {
      if (this.tempDeletingCategoria.id_categoria) {
        this.tempDeletingCategoria.deleted = true;
        this.negocio.categorias = this.negocio.categorias.filter(
          (itemCategoria) => itemCategoria
        );
      } else {
        this.deleteCategoriaByIndex();
      }
      this.tempIndexDeletingCategoria = null;
      this.tempDeletingCategoria = null;
      this.dialogDelete = false;
    },
    deleteCategoriaByIndex() {
      this.negocio.categorias = this.negocio.categorias.filter(
        (itemCategoria, indexItemCategoria) =>
          itemCategoria.indexOriginal !==
          this.tempDeletingCategoria.indexOriginal
      );
    },
    addNewCategoria() {
      const categoria = {
        id_categoria: null,
        descripcion: null,
        inserted: true,
        id_negocio: this.negocio.id_negocio,
        indexOriginal: this.negocio.categorias.length + 1
      };
      if (this.negocio.categorias.length > 0) {
        this.$v.negocioVuelidate.categorias.$touch();
        if (!this.$v.negocioVuelidate.categorias.$each.$invalid) {
          this.negocio.categorias.push(categoria);
        }
      } else {
        this.negocio.categorias.push(categoria);
      }
    },
    async guardarNegocio() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        const extension = this.negocio.file.name_file.split(".")[1];
        this.negocio.file.name_file =
          this.negocio.descripcion
            .toLowerCase()
            .replace(/ +/g, "_")
            .trim() +
          "." +
          extension;
        this.savingNegocio = true;
        const isNegocio = await this.existNegocio();
        this.negocio.id_empleado_modifica = user.empleado;
        if (!isNegocio) {
          axios
            .patch("/negocio/secure/cud", this.negocio)
            .then((response) => {
              if (response) {
                const data = response.data.data;
                if (response.data.status_code === 200) {
                  data.categorias = data.categorias.filter((itemCategoria) => {
                    delete itemCategoria.inserted;
                    delete itemCategoria.updated;
                    return !itemCategoria.deleted;
                  });
                  delete data.inserted;
                  delete data.updated;
                  self.negocio = data;
                  self.negocioBackup = JSON.parse(JSON.stringify(self.negocio));
                  self.dialogSave = true;
                } else {
                  console.log("No Insert");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingNegocio = false;
            });
        } else {
          self.savingNegocio = false;
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    async existNegocio() {
      if (this.negocioBackup.descripcion === this.negocio.descripcion) {
        return await false;
      } else {
        const self = this;
        return await axios
          .get("/negocio/secure/get/nombre?value=" + this.negocio.descripcion)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const exist =
                  (response.data.track_code &&
                    response.data.track_code === 3006) === undefined;
                if (exist) {
                  self.dialogErrorValidationNombreNegocio = true;
                  self.isUniqueNegocio = false;
                }
                return exist;
              } else {
                return false;
              }
            }
          })
          .catch((error) => {
            console.log(error);
            return false;
          })
          .finally(function() {});
      }
    },
    readFile(e) {
      let file;
      if (e.type === "drop") {
        file = e.dataTransfer.files[0];
      } else {
        file = e.target.files[0];
      }
      if (!file) return;
      const size = file.size / 1024 / 1024;
      if (size > 2) {
        this.dialogSize = true;
        return;
      }
      const reader = new FileReader();
      const fileReaderDataType = new FileReader();
      this.negocio.file.name_file = file.name;
      this.negocio.file.content_type = file.type;
      reader.readAsDataURL(file);
      reader.onload = (e) => {
        let result = e.target.result;
        this.negocio.file.content_b64 = result.split(",")[1];
      };
      fileReaderDataType.readAsArrayBuffer(file);
      fileReaderDataType.onloadend = (e) => {
        var arr = new Uint8Array(e.target.result).subarray(0, 4);
        var header = "";
        for (var i = 0; i < arr.length; i++) {
          header += arr[i].toString(16);
        }
        const mimeType = serviceCommons.mimeType(header);
        if (!mimeType.includes("image")) {
          this.dialogTypeFile = true;
          this.clearFile();
        }
      };
    },
    cancelGlobalChanges() {
      this.negocio = JSON.parse(JSON.stringify(this.negocioBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    getNegocioImg(url) {
      const self = this;
      axios
        .get(url)
        .then((response) => {
          if (response) {
            const data = response.data.data;
            if (response.data.status_code === 200) {
              self.negocio.file.content_b64 = data.content_b64;
              self.negocio.file.content_type = data.content_type;
              self.negocio.file.name_file = data.name_file;
              self.negocioBackup = JSON.parse(JSON.stringify(self.negocio));
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    }
  },
  created() {
    if (this.$route.params.negocio) {
      const negocio = this.serviceCommons.base64ToObject(
        this.$route.params.negocio
      );
      if (!negocio.categorias) {
        negocio.categorias = [];
      }
      negocio.file = {
        content_type: null,
        name_file: null,
        content_b64: null
      };
      const path_logo =
        urlServicesPlataformaFranquicia +
        "/file/secure/read/" +
        this.serviceCommons.stringToBase64(negocio.path_logo) +
        "?access_token=" +
        this.access_token;

      const path_logo_b64 =
        "/file/secure/read/b64/" +
        this.serviceCommons.stringToBase64(negocio.path_logo);
      this.getNegocioImg(path_logo_b64);
      negocio.path_logo = path_logo;
      this.negocio = negocio;
      this.negocioBackup = JSON.parse(JSON.stringify(this.negocio));
    }
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
